open Frame
open Temporary

type var_entry =
    {
      access : Translate.access ;
      (** access to the variable in the frame where it was defined *)
      ty : Types.ty
    }

type fun_entry =
    {
      label : Label.label ;
      formals : (Types.ty * bool) list ;
      (** arguments *)
      result : Types.ty ;
      (** type of element returned *)
    }

type const_entry =
    Int of Types.ty * int
      (** constant are integers, but can represented value of another type.
	The value of the constant is stored.
	For example [Int (Types.BOOL, 1)] represented a the boolean true *)
  | String of Ir.exp

type enventry =

    Var_entry of var_entry
      (** variables *)
  | Fun_entry of fun_entry
      (** procedure and function *)
  | Const_entry of const_entry
      (** constants *)
  | Exit_entry of Label.label
      (** exit label *)
