(** This module converts an AST into an IR Tree, and includes the type and symbol
 * checkings *)

(** symbol table : variables, procedures and functions *)
type venv = Env.enventry Symbol.table

(** symbol table : types *)
type tenv = Types.ty Symbol.table

(** variable access *)
type var = Ast.var

(** expression *)
type exp = Ast.exp

(** declaration ( constants, variables, types and procedures) *)
type dec = Ast.dec

(** type *)
type ty = Ast.ty_ty

(** ast *)
type ast = Ast.ast

val trans_ast : ast -> unit
  (**
    type checking,
    symbol checking,
    translation to intermediate code :) *)
